=== modified file 'lib/lp/buildmaster/tests/test_packagebuild.py'
--- lib/lp/buildmaster/tests/test_packagebuild.py	2012-01-04 16:39:15 +0000
+++ lib/lp/buildmaster/tests/test_packagebuild.py	2012-01-05 14:15:39 +0000
@@ -344,7 +344,7 @@
         def got_status(ignored):
             self.assertEqual(BuildStatus.FAILEDTOUPLOAD, self.build.status)
             self.assertResultCount(0, "failed")
-            self.assertIdentical(None, self.build._buildqueue_record)
+            self.assertIdentical(None, self.build.buildqueue_record)
 
         d = self.build.handleStatus('OK', None, {
             'filemap': {'/tmp/myfile.py': 'test_file_hash'},

=== modified file 'lib/lp/soyuz/browser/tests/test_builder.py'
--- lib/lp/soyuz/browser/tests/test_builder.py	2012-01-04 16:39:15 +0000
+++ lib/lp/soyuz/browser/tests/test_builder.py	2012-01-05 14:15:39 +0000
@@ -5,7 +5,7 @@
 
 __metaclass__ = type
 
-from testtools.matchers import Equals
+from testtools.matchers import LessThan
 from zope.component import getUtility
 from zope.security.proxy import removeSecurityProxy
 
@@ -67,14 +67,10 @@
 
     layer = LaunchpadFunctionalLayer
 
-    # XXX rvb: the 3 additional queries per build are the result of the calls
-    # to:
-    # - builder.currentjob
-    # - buildqueue.specific_job
-    # These could be converted into cachedproperty and pre-populated in
-    # bulk but several tests assert that the value returned by these
-    # these properties are up to date.  Since they are not really expensive
-    # to compute I'll leave them as regular properties for now.
+    # XXX rvb: the 2 queries per build are the result of the calls to
+    # build.buildqueue_record.  It was decided not to make it a cachedproperty
+    # because the code relies on the fact that the property always returns the
+    # current record.
 
     def test_builders_binary_package_build_query_count(self):
         def create_build():
@@ -82,10 +78,13 @@
             queue = build.queueBuild()
             queue.markAsBuilding(build.builder)
 
+        nb_objects = 2
         recorder1, recorder2 = record_two_runs(
-            builders_homepage_render, create_build, 2)
+            builders_homepage_render, create_build, nb_objects)
 
-        self.assertThat(recorder2, HasQueryCount(Equals(recorder1.count)))
+        self.assertThat(
+            recorder2,
+            HasQueryCount(LessThan(recorder1.count + 2 * nb_objects + 1)))
 
     def test_builders_recipe_build_query_count(self):
         def create_build():
@@ -93,10 +92,13 @@
             queue = build.queueBuild()
             queue.markAsBuilding(build.builder)
 
+        nb_objects = 2
         recorder1, recorder2 = record_two_runs(
-            builders_homepage_render, create_build, 2)
+            builders_homepage_render, create_build, nb_objects)
 
-        self.assertThat(recorder2, HasQueryCount(Equals(recorder1.count)))
+        self.assertThat(
+            recorder2,
+            HasQueryCount(LessThan(recorder1.count + 2 * nb_objects + 1)))
 
     def test_builders_translation_template_build_query_count(self):
         def create_build():
@@ -110,7 +112,10 @@
             queue = queueset.get(job_id)
             queue.markAsBuilding(self.factory.makeBuilder())
 
+        nb_objects = 2
         recorder1, recorder2 = record_two_runs(
-            builders_homepage_render, create_build, 2)
+            builders_homepage_render, create_build, nb_objects)
 
-        self.assertThat(recorder2, HasQueryCount(Equals(recorder1.count)))
+        self.assertThat(
+            recorder2,
+            HasQueryCount(LessThan(recorder1.count + 2 * nb_objects + 1)))

